Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Imports System.IO.Ports


Friend Class frmMain
	Inherits System.Windows.Forms.Form
	'*********************************************************************************
    '   ICS Serial Keyboard Program                              Revised 9-9-2015
	'
    '   ICS Serial Keyboard Program is an interactive Serial Control program that
    '   demonstrates how to control ICS's Serial Devicesr from a VB.Net program.
    '   
    '   Copyright ICS Electronics 2015
	'********************************************************************************
    Dim AddrFlag As Boolean     'true when address prefix required
    Dim PackFlag As Boolean     'ture for packet mode
    Public AddrSetFlg As Boolean 'true when a device address selected
    Dim addr As String           'device address byte
    Dim rxbufsize As Long
    Dim txbufsize As Long
    Dim LastOutStr As String
    Public ErrFlag As Boolean
    Public QueryFlg As Boolean  'identifies command as a query
    Dim Settings1 As String = "9600,N,8,1"
    '"2400,N,8,1"
    '"4800,N,8,1"
    '"9600,N,8,1"
    '"19200,N,8,1"
    '"38400,N,8,1"
    'Dim MSComm2 As MSComm
    'Dim MSComm1 As MSCommLib.MSComm

    Dim OutStr As String
    Dim NL As String = Chr(13) & Chr(10)
    Public IDNTestFlg As Integer = 0
    Public LpCount As Integer = 0
    Public CMDloopFlg As Integer = 0
    'Public MSComm1 As MSCommLib.MSComm = New MSCommLib.MSComm
    Public MSComm1 As System.IO.Ports.SerialPort = New System.IO.Ports.SerialPort
    Public RstTime As Short
    Public DevSet As Short
    Public Dev As Short         'device address
    Public CmdLPFlg As Short
    Dim Rev As String = "Revised N10 9-18-2015"

    Sub Tdelay(ByRef delaytime As Double)
        Try
            Dim starttime As Double
            starttime = VB.Timer()
            Do Until VB.Timer() >= (starttime + delaytime)
            Loop
        Catch ex As Exception
            MsgBox("Tdelay Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdCmdtst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStartLp.Click
        Try
            If combCmd.Text = "" Then
                Beep()
                txtResults.Text = "No command specified.  Enter a command before starting the Command Loop"
            Else
                CMDloopFlg = 1
                Timer1.Enabled = True
            End If
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdCmdtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdStopLp.Click
        Try
            CMDloopFlg = LpCount = 0
            txtCount.Visible = False
            lblCount.Visible = False
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub

    Sub cmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdExit.Click
        Try
            If MSComm1.IsOpen = True Then
                MSComm1.Close()            'Close the serial port.
            End If
            End
        Catch ex As Exception
            MsgBox("Exit-closing COM Port Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdIDNTst_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        Try
            combCmd.Text = "*idn?"
            IDNTestFlg = 1
            Timer1.Enabled = True
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdIDNtstoff_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        Try
            IDNTestFlg = LpCount = 0
            txtCount.Visible = False
            lblCount.Visible = False
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdRead_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdRead.Click
        Dim Buffer As String = ""
        Dim Rdcount As Integer
        Dim L As Short          'buffer length to show character count
        Dim LN As Short
        Dim N As Short
        Dim Letx As Short
        Dim Cksum As Integer
        Dim Term$
        Dim I As Short

        txtError.Visible = False
        RstTime = 0
        Term$ = ""
        If ckLF.Checked Then
            Term$ = Chr(10)
        Else
            If ckCR.Checked Then
                Term$ = Chr(13)
            End If
        End If

        Try
            'one read loop for all reads
            Buffer = ""
            Rdcount = 0
            Do
                Buffer = Buffer & MSComm1.ReadExisting      'read to terminator
                If Rdcount > 40000 Then   'hangup error exit
                    txtError.Text = "Program Timeout - no response"
                    txtError.Visible = True
                    Beep()
                    txtResults.Text = "Bad response =" & Buffer
                    CmdLPFlg = 0        'stop any test loop
                    GoTo readexit
                End If
                Rdcount = Rdcount + 1
            Loop Until (InStr(Buffer$, Term$)) Or (Rdcount > 30000)

            Rdcount = 0
            If ckPrompt.Checked Then
                Do                                           'read to prompt
                    Buffer = Buffer & MSComm1.ReadExisting
                    Rdcount = Rdcount + 1
                Loop Until (InStr(Buffer$, ">")) Or (Rdcount > 10000)
                If Rdcount > 10000 Then
                    txtError.Text = "Prompt not found. Uncheck Next Msg Prompt box if communicating with a non-ICS device"
                    txtError.Visible = True
                    Beep()
                End If
            End If

            Call Tdelay(0.02)
            Rdcount = 0
            Do                                              'get last linefeed if missed
                Buffer = Buffer & MSComm1.ReadExisting
                Rdcount = Rdcount + 1
            Loop Until MSComm1.BytesToRead() = 0 Or (Rdcount > 1000)

        Catch ex As Exception
            txtResults.Text = "Read error, response =" & Buffer
            CmdLPFlg = 0        'stop any test loop
            GoTo readexit       'error exit
        End Try

        'process buffer for display
        L = Len(Buffer)
        If L = 0 Then
            txtResults.Text = "Nothing in buffer"
            GoTo readexit
        Else
            txtResults.Text = ""
            If ckDispAll.Checked = 0 Then          'ckDispAll.Value  = 0 for short display string
                If PackFlag = 0 Then                'not a packet response
                    If InStr(Buffer$, vbCr) <> 0 Then
                        Buffer$ = VB.Left(Buffer$, InStr(Buffer$, vbCr) - 1)
                    ElseIf InStr(Buffer$, vbLf) <> 0 Then
                        Buffer$ = VB.Left(Buffer$, InStr(Buffer$, vbLf) - 1)
                    End If
                Else                                'packet response display
                    If VB.Left(Buffer$, 1) = Chr(6) Then
                        txtResults.Text = "ACK Packet received" & NL
                        Letx = InStr(Buffer$, Chr(3))
                        If Letx <> 0 Then                       'verify checksum
                            Cksum = 0
                            For I = 1 To Letx
                                Cksum = Cksum Xor (Asc(Mid$(Buffer$, I, 1)))
                            Next I
                            If Asc(Mid$(Buffer$, Letx + 1, 1)) = Cksum Then
                                txtResults.Text = txtResults.Text & "Cksum verified, Cksum = " & Str$(Cksum) & NL
                            Else
                                txtResults.Text = txtResults.Text & "Cksum fails" & NL
                                Beep()
                            End If
                        Else
                            txtResults.Text = txtResults.Text & "ETX char missing" & NL
                            Beep()
                        End If
                        Buffer$ = VB.Right(Buffer$, (L - 2))      'removes leading chars
                        Buffer$ = VB.Left(Buffer$, InStr(Buffer$, Chr(3)) - 1) 'keeps ESR value
                        If QueryFlg = True Then
                            Buffer$ = "RespStr= " + Buffer$
                        Else
                            Buffer$ = "ESR value= " + Buffer$
                        End If
                    ElseIf VB.Left(Buffer$, 1) = Chr(21) Then
                        txtResults.Text = "NAK packet received" & NL
                        Letx = InStr(Buffer$, Chr(3))
                        If Letx <> 0 Then                       'verify checksum
                            Cksum = 0
                            For I = 1 To Letx
                                Cksum = Cksum Xor (Asc(Mid$(Buffer$, I, 1)))
                            Next I
                            If Asc(Mid$(Buffer$, Letx + 1, 1)) = Cksum Then
                                txtResults.Text = txtResults.Text & "Cksum verified, Cksum = " & Str$(Cksum) & NL
                            Else
                                txtResults.Text = txtResults.Text & "Cksum fails" & NL
                                Beep()
                            End If
                        Else
                            txtResults.Text = txtResults.Text & "ETX char missing" & NL
                            Beep()
                        End If
                        Buffer$ = VB.Right(Buffer$, (L - 2))      'removes leading chars
                        Buffer$ = VB.Left(Buffer$, InStr(Buffer$, Chr(3)) - 1) 'keeps ESR value
                        Buffer$ = "ESR value= " + Buffer$
                    Else
                        txtResults.Text = "Did not receive a ACK/NAK packet" & NL

                    End If
                End If
            ElseIf ckDispAll.Checked = True And PackFlag = False Then                               'ckDispAll.Value = 1 for ful display string
                Do Until InStr(Buffer$, Chr(13)) = 0     'replace CR loop
                    LN = Len(Buffer$)
                    N = InStr(Buffer$, Chr(13))
                    If N = 1 Then
                        Buffer$ = "<cr>" + VB.Right(Buffer$, LN - N)      'replace first char
                    Else
                        Buffer$ = VB.Left(Buffer$, N - 1) + "<cr>" + VB.Right(Buffer$, LN - N) 'replace any other char
                    End If
                Loop

                Do Until InStr(Buffer$, Chr(10)) = 0     'replace LF loop
                    LN = Len(Buffer$)
                    N = InStr(Buffer$, Chr(10))
                    If N = 1 Then
                        Buffer$ = "<lf>" + VB.Right(Buffer$, LN - N)      'replace first char
                    Else
                        Buffer$ = VB.Left(Buffer$, N - 1) + "<lf>" + VB.Right(Buffer$, LN - N) 'replace any other char
                    End If
                Loop
            ElseIf ckDispAll.Checked = True And PackFlag = True Then
                txtResults.Text = "Cannot display all characters in Packet Mode"
                txtResults.Text = txtResults.Text + NL + "Uncheck Display All Characters and repeat the command"
                Beep()
            End If
            txtResults.Text = txtResults.Text & Buffer$
            If ckByteCnt.CheckState = 1 Then
                txtResults.Text = txtResults.Text & NL & "Count = " & Str(L)
            End If
        End If
readexit:
    End Sub

    Sub cmdSend_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles cmdSend.Click
        Dim lenout As Integer
        Dim Cksum As Integer
        Dim I As Integer
        Dim Buffer As String = ""
        Dim Rdcount As Integer
        Dim OutStrD As String

        txtError.Visible = False

        If Len(combCmd.Text) = 0 And Len(LastOutStr) = 0 Then   'if nothing to send
            Beep()
            txtError.Text = "Nothing to send"
            txtError.Visible = True
            GoTo SendExit
        End If

        Try
            If MSComm1.BytesToRead() Then
                MSComm1.DiscardInBuffer()       'clear input buffer
            End If
            RstTime = 0
            ' txtResults.Text = ""

            If Len(combCmd.Text) = 0 And Len(LastOutStr) = 0 Then   'if nothing to send
                Beep()
                txtError.Text = "Nothing to send"
                txtError.Visible = True
                GoTo SENDEXIT
            Else
                If ((AddrFlag = True) And (AddrSetFlg = False)) Or ((PackFlag = True) And (AddrSetFlg = False)) Then
                    Beep()
                    txtError.Text = "Missing a device address.  Enter a valid network address and click Set"
                    txtError.Visible = True
                    GoTo SendExit
                Else
                    If Len(combCmd.Text) = 0 Then
                        combCmd.Text = LastOutStr
                    End If
                    LastOutStr = combCmd.Text                       'save msg

                    OutStr = combCmd.Text
                    If PackFlag = False Then                        'std mode
                        OutStrD = OutStr
                        If ckCR.Checked = True Then
                            OutStr = OutStr + Chr(13)
                            OutStrD = OutStr + "<cr>"
                        End If
                        If ckLF.Checked = True Then
                            OutStr = OutStr + Chr(10)
                            OutStrD = OutStrD + "<lf>"
                        End If
                        If AddrFlag = True Then
                            OutStr = Chr(2) + addr + OutStr         'addr mode
                            OutStrD = "<stx>" + addr + OutStr
                        End If
                    Else                                            'packet mode
                        OutStr = Chr(2) + addr + OutStr + Chr(3)
                        OutStrD = "<stx>" + addr + OutStr + "<etx>"
                        lenout = Len(OutStr)
                        Cksum = 0
                        For I = 1 To lenout
                            Cksum = Cksum Xor (Asc(Mid$(OutStr, I, 1)))
                        Next I
                        OutStr = OutStr + Chr(Cksum)
                        OutStrD = OutStrD + Chr(Cksum)
                    End If

                    lenout = Len(OutStr)
                    If lenout > txbufsize Then lenout = (txbufsize - 1)
                    MSComm1.Write(OutStr)                         'output string

                    QueryFlg = 0
                    If (InStr(OutStr, "?") <> 0) Then
                        QueryFlg = 1
                    Else
                        txtResults.Text = "Sent " + OutStrD
                    End If

                    If (ckAuto.Checked) And (InStr(OutStr, "?") <> 0) Or (ckRead.Checked) Then
                        Call cmdRead_Click(cmdRead, New System.EventArgs())   'read query response
                    ElseIf PackFlag = True Then
                        Call cmdRead_Click(cmdRead, New System.EventArgs())    'read response packet
                    ElseIf ckPrompt.Checked Then
                        Do                                           'read for prompt
                            Buffer = Buffer & MSComm1.ReadExisting
                            Rdcount = Rdcount + 1
                        Loop Until (InStr(Buffer$, ">")) Or (Rdcount > 10000)
                        If Rdcount > 10000 Then
                            txtError.Text = "Prompt not found. Uncheck Next Msg Prompt box if communicating with a non-ICS device"
                            txtError.Visible = True
                            Beep()
                        End If
                    End If

                End If
            End If
        Catch ex As Exception
            MsgBox("Send Clear Buffer-bytes to read error =" & ex.Message)
        End Try
SendExit:

    End Sub

    Sub frmMain_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        txtRev.Text = Rev
        combCmd.Items.Insert(0, "*esr?")
        combCmd.Items.Insert(1, "*idn?")
        combCmd.Items.Insert(2, "*stb?")
        Timer1.Enabled = False
        cmdInitCP.Enabled = True
        cmdBaud.Enabled = True
        cmdSetDevAddr.Enabled = False
        cmdSend.Enabled = False
        cmdRead.Enabled = False
        cmdIDNtst.Enabled = False
        cmdIDNtstoff.Enabled = False
        cmdStartLp.Enabled = False
        cmdStopLp.Enabled = False
        cmdCntlE.Enabled = False
        cmdCntlF.Enabled = False
        cmdCLS.Enabled = False
        cmdRST.Enabled = False
        AddrFlag = False
        PackFlag = False
        AddrSetFlg = False
        txbufsize = 256
        rxbufsize = 256
        ckLF.Checked = True
        optProtNone.Checked = True
        optTime5.Checked = True
    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Try
            If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
                txtCount.Visible = False
                LpCount = 0
            ElseIf IDNTestFlg = 1 Then 'IDN read loop
                combCmd.Text = "*IDN?"
                Call cmdSend_Click(cmdSend, New System.EventArgs())
                txtCount.Visible = True
                lblCount.Visible = True
                LpCount = LpCount + 1
                txtCount.Text = LpCount
            ElseIf CMDloopFlg = 1 Then 'loop using the string in the combCmd.text
                If combCmd.Text = "" Then
                    Beep()
                    txtError.Text = "Command box empty"
                    txtError.Visible = True
                Else
                    Call cmdSend_Click(cmdSend, New System.EventArgs())
                    txtCount.Visible = True
                    lblCount.Visible = True
                    LpCount = LpCount + 1
                    txtCount.Text = LpCount
                End If
            End If

        Catch ex As Exception
            MsgBox("Timer1 Error =" & ex.Message)
        End Try
    End Sub

    Private Sub combCmd_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles combCmd.KeyPress
        Try
            If e.KeyChar = Chr(13) Then
                Call cmdSend_Click(cmdSend, New System.EventArgs())
            End If
        Catch ex As Exception
            MsgBox("Device Command Window keypress Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdBaud_Click(sender As System.Object, e As System.EventArgs) Handles cmdBaud.Click
        MSComm1.BaudRate = Baud_Combo.Text
        txtResults.Text = "Baud rate set to " + Baud_Combo.Text + " baud"
    End Sub

    Private Sub cmdInitCP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdInitCP.Click
        Try
            If MSComm1.IsOpen() = True Then
                MSComm1.Close()
            End If
            ' Allow the user to set the appropriate properties.
            MSComm1.PortName = CB_COM.Text
            ' MSComm1.BaudRate = 9600
            MSComm1.Parity = Parity.None
            MSComm1.DataBits = 8
            MSComm1.StopBits = StopBits.One
            MSComm1.Handshake = Handshake.None
            MSComm1.ReadTimeout = 5000
            MSComm1.WriteTimeout = 500
            'MSComm1.InputLen = 0
            MSComm1.RtsEnable = True
            MSComm1.DtrEnable = True

            'note add a try loop incase a port is already opened.
            MSComm1.Open()
            cmdSetDevAddr.Enabled = True
            txtResults.Text = "COM port opened"
            cmdSetDevAddr.Enabled = True
            cmdSend.Enabled = True
            cmdRead.Enabled = True
            cmdIDNtst.Enabled = True
            cmdIDNtstoff.Enabled = True
            cmdStartLp.Enabled = True
            cmdStopLp.Enabled = True
            cmdCntlE.Enabled = True
            cmdCntlF.Enabled = True
            cmdCLS.Enabled = True
            cmdRST.Enabled = True
            Timer1.Enabled = True

        Catch ex As Exception
            MsgBox("cmdInit Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdSetDevAddr_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSetDevAddr.Click
        txtError.Visible = False
        RstTime = 0
        Dev = Val(txtDevAddr.Text)
        If (Dev > 0 And Dev < 31) Then
            If Val(txtDevAddr.Text) > 9 Then
                addr = Chr(Val(txtDevAddr.Text) + 48)
            Else
                addr = (txtDevAddr.Text)
            End If
            DevSet = 1
            AddrSetFlg = True
            txtResults.Text = "Device address set to " & addr
        Else
            txtError.Text = "Device Address out of range"
            txtError.Visible = True
            Beep()
        End If
    End Sub

    Private Sub cmdCntlF_Click(sender As System.Object, e As System.EventArgs) Handles cmdCntlF.Click

        If DevSet = True Then
            MSComm1.Write(Chr(2) + Str(Dev) + Chr(6))           'CTRL-F
        Else
            MSComm1.Write(Chr(6))
        End If

        'If FDMode = False Then CPSetRTS (CP)    'set RTS on if half duplex
        txtResults.Text = "CNTL-F sent"
    End Sub

    Private Sub cmdCntlE_Click(sender As System.Object, e As System.EventArgs) Handles cmdCntlE.Click
        If DevSet = True Then
            MSComm1.Write(Chr(2) + Str(Dev) + Chr(5))           'CTRL-E
        Else
            MSComm1.Write(Chr(5))
        End If

        'If FDMode = False Then CPSetRTS (CP)    'set RTS on if half duplex
        txtResults.Text = "CNTL-E sent"
    End Sub

    Private Sub optProtNone_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optProtNone.CheckedChanged
        AddrFlag = False
        PackFlag = False
        ckPrompt.Checked = True
        optProtAddr.Checked = False
        optProtPack.Checked = False
    End Sub

    Private Sub optProtAddr_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optProtAddr.CheckedChanged
        AddrFlag = True
        PackFlag = False
        cmdSetDevAddr.Enabled = True
        ckPrompt.Checked = True
        optProtNone.Checked = False
        optProtPack.Checked = False
        txtDevAddr.Focus()
    End Sub

    Private Sub optProtPack_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optProtPack.CheckedChanged
        AddrFlag = False
        PackFlag = True
        cmdSetDevAddr.Enabled = True
        ckPrompt.Checked = False
        optProtNone.Checked = False
        optProtAddr.Checked = False
        txtDevAddr.Focus()
    End Sub

    Private Sub cmdIDNtst_Click_1(sender As System.Object, e As System.EventArgs) Handles cmdIDNtst.Click
        combCmd.Text = "*idn?"
        IDNTestFlg = 1
    End Sub

    Private Sub cmdIDNtstoff_Click_1(sender As System.Object, e As System.EventArgs) Handles cmdIDNtstoff.Click
        IDNTestFlg = 0
        If (CMDloopFlg = 0) And (IDNTestFlg = 0) Then
            txtCount.Visible = False
            lblCount.Visible = False
            LpCount = 0
        End If
    End Sub

    Private Sub optTime1_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optTime1.CheckedChanged
        Timer1.Interval = 100   'sets timer interval in ms
        'optTime1.Checked = False
        optTime3.Checked = False
        optTime5.Checked = False
        optTime1s.Checked = False
    End Sub

    Private Sub optTime3_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optTime3.CheckedChanged
        Timer1.Interval = 300   'sets timer interval in ms
        optTime1.Checked = False
        'optTime3.Checked = False
        optTime5.Checked = False
        optTime1s.Checked = False
    End Sub

    Private Sub optTime5_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optTime5.CheckedChanged
        Timer1.Interval = 500   'sets timer interval in ms
        optTime1.Checked = False
        optTime3.Checked = False
        ' optTime5.Checked = False
        optTime1s.Checked = False
    End Sub

    Private Sub optTime1s_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles optTime1s.CheckedChanged
        Timer1.Interval = 1000   'sets timer interval in ms
        optTime1.Checked = False
        optTime3.Checked = False
        optTime5.Checked = False
        ' optTime1s.Checked = False
    End Sub

    Private Sub cmdCLS_Click_1(sender As System.Object, e As System.EventArgs) Handles cmdCLS.Click
        Try
            combCmd.Text = "*CLS"
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        Catch ex As Exception
            MsgBox("Error =" & ex.Message)
        End Try
    End Sub

    Private Sub cmdRST_Click_1(sender As System.Object, e As System.EventArgs) Handles cmdRST.Click
        Try
            combCmd.Text = "*RST"
            Call cmdSend_Click(cmdSend, New System.EventArgs())
        Catch ex As Exception
            MsgBox("RST Error =" & ex.Message)
        End Try
    End Sub
End Class

